;include humanMaths.asm


BASE_DEC	equ 0
BASE_HEX	equ 1
BASE_OCT	equ 2
BASE_BIN	equ 3
BASE_FLT	equ 4


; priorities are
; dec > float > hex > bin > oct , I think ^^'

sconvToDec proc UseAll pDest,pSrc
	local isNegative,dwBase
	local pSrcLastChar
	local NumABCDEF,NumDots,LastChar
	local smallString[4]:byte
	
	
	;-----[ reset stuff ]------\
	xor eax,eax
	mov isNegative,eax
	mov dwBase,eax ; BASE_DEC
	mov NumABCDEF,eax
	mov NumDots,eax
	mov LastChar,eax
	;--------------------------/
	
	
	;----------[ find base of pSrc ]---------------------------[
	;-----[ check sign and hex ]-----------------------\
	mov esi,pSrc
	.while byte ptr[esi]=='-'
		xor isNegative,1
		inc esi
	.endw
	.if word ptr[esi]=='x0' ; 0x213 is definitely a hex
		inc NumABCDEF
		add esi,2
	.endif
	.while byte ptr[esi]=='0' ; remove trailing zeros
		inc esi
	.endw
	mov pSrc,esi ; set pSrc to the new start..
	;--------------------------------------------------/
	
	;-------[ count types of chars ]------------------\
	@@:
	mov al,[esi]
	.if al>='A' && al<='F'
		inc NumABCDEF
	.elseif al=='b' && (byte ptr[esi+1])==0
		; to avoid binary being detected as hex
	.elseif al>='a' && al<='f'
		inc NumABCDEF
	.elseif al=='.'
		inc NumDots
	.endif
	inc esi
	test al,al
	jz @F
	
	jmp @B ; go to next char
	@@: ; done with chars
	dec esi
	dec esi
	movzx eax,byte ptr[esi]
	mov LastChar,eax
	mov pSrcLastChar,esi
	;-------------------------------------------------/
	
	;-----[ determine ]----------------\
	.if NumABCDEF==0
		; al = LastChar
		.if al=='b'
			mov dwBase,BASE_BIN			
		.elseif al=='o'
			mov dwBase,BASE_OCT
		.elseif al=='h'
			mov dwBase,BASE_HEX
		.endif
	.else ; NumABCDEF>=1
		mov dwBase,BASE_HEX
	.endif
	.if NumDots
		mov dwBase,BASE_FLT
	.endif
	
	
	comment %
	001010100  -> decimal
	001010101b -> binary
	010101000o -> octal
	010101010h -> hexadecimal
	0x1010101h -> hexadecimal
	ABCDEF -> hexadecimal
	0x100000b -> hexadecimal
	100000bh  -> hexadecimal
	010.0  -> float
	
	%	
	;----------------------------------/
	;----------------------------------------------------------/
	
	;----[ dispatch ]-------------------\
	mov ecx,dwBase
	mov esi,pSrc
	mov edi,pDest
	mov al,[esi]
	cmp cl,BASE_DEC
	je dec_to_dec
	cmp cl,BASE_FLT
	je dec_to_dec
	cmp cl,BASE_BIN
	je bin_to_dec
	cmp cl,BASE_OCT
	je oct_to_dec
	cmp cl,BASE_HEX
	je hex_to_dec
	
	;-----------------------------------/
	
	;------[ dump zero, meaning empty input ]-----\
	dump_zero:
		mov edi,pDest
		mov word ptr [edi],'0'
		ret
	;---------------------------------------------/
	
	;----------------[ dec-> dec ]---------------------[
	dec_to_dec: ; also handles floats
	
		;--[ check empty ]---\
		cmp al,'0'
		jl dump_zero
		cmp al,'9'
		jg dump_zero
		;--------------------/
		;---[ go to last char ]-----\
		@@:
			mov al,[esi+1]
			cmp al,'0'
			jl @F
			cmp al,'9'
			jg @F
			inc esi
			jmp @B
		@@:
		;---------------------------/
		.while esi>=pSrc
			mov al,[esi]
			mov [edi],al
			inc edi
						
			dec esi
		.endw
		jmp finalize
	;--------------------------------------------------/
	
	;-------------[ bin-> dec ]---------------------[
	bin_to_dec:
		;------[ for each digit ]--------------------------------------[
		lea ebx,smallString
		mov dword ptr[edi],'0'
		mov dword ptr[ebx],'1'
		mov al,[esi]
		.while (al>='0' && al<='1')
			invoke strMulFixOneRevDec,edi,1
			.if al!='0'
				invoke strAddTwoRevDecs,edi,ebx
			.endif
				
			inc esi
			mov al,[esi]
		.endw
		cmp esi,pSrc
		je dump_zero
		;--------------------------------------------------------------/
		
		.while byte ptr[edi]
			inc edi
		.endw
		
		jmp finalize
	;-----------------------------------------------/
	
	;-------------[ oct-> dec ]---------------------[
	oct_to_dec:
		;------[ for each digit ]--------------------------------------[
		lea ebx,smallString
		mov dword ptr[edi],'0'
		mov dword ptr[ebx],'0'
		mov al,[esi]
		.while (al>='0' && al<='7')
			invoke strMulFixOneRevDec,edi,3
			.if al!='0'
				mov smallString[0],al
				invoke strAddTwoRevDecs,edi,ebx
			.endif
				
			inc esi
			mov al,[esi]
		.endw
		cmp esi,pSrc
		je dump_zero
		;--------------------------------------------------------------/
		
		.while byte ptr[edi]
			inc edi
		.endw
		
		jmp finalize
	;-----------------------------------------------/
	
	
	;-------------[ hex-> dec ]---------------------[
	hex_to_dec:
		prints esi
		lea ebx,smallString
		mov dword ptr[edi],'0'
		mov dword ptr[ebx],'0'
		;------[ for each digit ]--------------------------------------[
		mov al,[esi]
		.while (al>='0' && al<='9') || (al>='A' && al<='F') || (al>='a' && al<='f')
			invoke strMulFixOneRevDec,edi,4
			.if al!='0'
				mov dword ptr[ebx],0
				.if al>='A' && al<='F'
					sub al,'A'-'0'	
					mov smallString[1],'1'
				.elseif al>='a' && al<='f'
					sub al,'a'-'0'	
					mov smallString[1],'1'
				.endif
				mov smallString[0],al
				invoke strAddTwoRevDecs,edi,ebx
			.endif
				
			inc esi
			mov al,[esi]
		.endw
		cmp esi,pSrc
		je dump_zero
		;--------------------------------------------------------------/
		
		.while byte ptr[edi]
			inc edi
		.endw
		
		jmp finalize
	;-----------------------------------------------/
	
	
	
	;------[ finalize output ]---------------\
	finalize:
		.if isNegative
			mov byte ptr[edi],'-'
			inc edi
		.endif
		mov byte ptr[edi],0
		dec edi
		
		mov esi,pDest
		.while esi<edi
			mov al,[esi]
			mov bl,[edi]
			mov [edi],al
			mov [esi],bl
			inc esi
			dec edi
		.endw		
		ret
	;----------------------------------------/
	
sconvToDec endp